<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org" xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security" layout:decorate="~{layout3}">
<head>
  <meta charset="UTF-8" />
  <title>KPI Lecturer</title>
  <!-- SweetAlert2 CSS -->
  <link rel="stylesheet" th:href="@{/css/sweetalert2.min.css}">
  <!-- SweetAlert2 JS -->
  <script th:src="@{/js/sweetalert2.js}"></script>
  <script>
    const MAX_FILE_SIZE = 2000 * 1024; // 500 KB in bytes

    // Function to add a new file input row
    function addFileRow() {
      const table = document.getElementById("fileTableBody");
      const rows = table.getElementsByTagName("tr");

      // Check if there are already 5 rows
      if (rows.length >= 5) {
        Swal.fire({
          icon: 'warning',
          title: 'Limit Reached',
          text: 'A maximum of 5 file rows is allowed.',
          confirmButtonText: 'OK'
        });
        return; // Prevent adding more rows
      }

      // Create a new row if the maximum has not been reached
      const row = document.createElement("tr");
      row.innerHTML = `
      <td><input type="file" class="form-control" name="file" onchange="validateFileSize(this)"></td>
      <td><button type="button" class="btn btn-danger btn-sm" onclick="removeFileRow(this)"><i class="fa fa-trash"></i></button></td>
    `;
      table.appendChild(row);
    }

    // Function to validate file size
    function validateFileSize(input) {
      const file = input.files[0];
      if (file && file.size > MAX_FILE_SIZE) {
        Swal.fire({
          icon: 'error',
          title: 'File Too Large',
          text: 'File size must be less than 2 MB.',
          confirmButtonText: 'OK'
        });
        input.value = ""; // Clear the input if file size is too large
      }
    }

    // Function to remove a file input row
    function removeFileRow(button) {
      const table = document.getElementById("fileTableBody");
      const rows = table.getElementsByTagName("tr");

      // Only remove the row if there's more than one row remaining
      if (rows.length > 1) {
        const row = button.closest("tr");
        row.remove();
      } else {
        Swal.fire({
          icon: 'info',
          title: 'Cannot Delete',
          text: 'At least one file row is required.',
          confirmButtonText: 'OK'
        });
      }
    }

    function getId(id){
      let selectedValue = id.value;
      if (selectedValue) {
        fetch(`/api/v1/kpiposition?position=${selectedValue}`)
                .then(response => response.json())
                .then(data => {
                  if (data.responseCode === "200") {
                    document.getElementById("indikator").innerText = data.data.indikator;
                    document.getElementById("kpi").innerText = data.data.kpi;
                    document.getElementById("syaratA").innerText = data.data.syaratAa;
                    document.getElementById("syaratB").innerText = data.data.syaratBb;
                    document.getElementById("syaratC").innerText = data.data.syaratCc;
                    document.getElementById("periode").innerText = data.data.periodeEvaluasi;
                    document.getElementById("id").value = data.data.id;

                    document.getElementById("detail").style.display = "block";
                    console.log(data); // This should log if the above condition is true
                  } else {
                    Swal.fire({
                      icon: 'error',
                      title: 'Error',
                      text: 'Data not found or error fetching data.',
                      confirmButtonText: 'OK'
                    });
                  }
                })
                .catch(error => {
                  Swal.fire({
                    icon: 'error',
                    title: 'Error',
                    text: 'Failed to fetch data from the API.',
                    confirmButtonText: 'OK'
                  });
                  console.error("Error fetching data:", error);
                });
      } else {
        document.getElementById("detail").style.display = "none";
      }
    }

    function batal(){
      document.getElementById("detail").style.display = "none";
    }
  </script>
</head>
<body>

<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
  <div th:include="sidebar/sidebar_kpi_dosen::sidebar_kpi_dosen" th:remove="tag">
    sidebar
  </div>

  <main class="bd-main-xxl">
    <div class="row">
      <div class="col-md-12">
        <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
          <i class="fa fa-circle text-secondary"></i> KPI Lecturer
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-md-12">
        <div class="alert alert-success mb-3" role="alert" th:if="${berhasil != null}">
          <i class="fa fa-check"></i> <span th:text="${berhasil}"></span>
        </div>
        <form class="form-horizontal" th:action="@{/kpi_lecturer/save}" th:object="${pengisianKpiDosen}" method="post" enctype="multipart/form-data">
          <div class="card shadow-sm border-0">
            <div class="card-header p-4">
              <div class="d-flex justify-content-between">
                <span class="fw-bold text-secondary">Form Report KPI</span>
              </div>
            </div>
            <div class="card-body">
              <div class="mb-3">
                <label for="idKpi" class="form-label text-secondary">K P I</label>
                <select class="form-select" id="idKpi" onchange="getId(this)" th:field="*{lecturerClassKpi}">
                  <option value="">-- pilih --</option>
                  <option th:each="data : ${listKpi}" th:text="${data.getKpi()+' - ('+data.getPeriodeEvaluasi()+')'}" th:value="${data.id}">sdasd</option>
                </select>
                <div th:if="${#fields.hasErrors('lecturerClassKpi')}" class="error-message" th:errors="*{lecturerClassKpi}" style="color: red;"></div>
              </div>

              <div class="mb-3" id="detail" style="display: none;">
                <div class="card shadow border-0">
                  <div class="card-body">
                    <div class="row">
                      <div class="col-md-12 text-end">
                        <span style="padding: 5px; background-color: #FF7777; color: white; border-radius: 6px; font-size: 14px;">
                          <i class="fa fa-clock"></i> &nbsp; <b id="periode">Periode Bulanan</b>
                        </span>
                      </div>
                    </div>

                    <div class="row">
                      <div class="col-md-12">
                        <b>KPI</b>
                        <input type="hidden" id="id" name="idKpi">
                        <p style="color: #475569; font-size: 14px;" id="kpi">Bersama Kabag IT melakukan dokumentasi pembuatan atau pengembangan aplikasi system informasi yang dibutuhkan oleh Institut agama Islam tazkia</p>
                      </div>
                    </div>

                    <div class="row">
                      <div class="col-md-12">
                        <b>Indikator</b>
                        <p style="color: #475569; font-size: 14px;" id="indikator">Bersama Kabag IT melakukan dokumentasi pembuatan atau pengembangan aplikasi system informasi yang dibutuhkan oleh Institut agama Islam tazkia</p>
                      </div>
                    </div>

                    <div class="row mb-3">
                      <div class="col-md-4" style="border-right: 1px solid #cfcbca">
                        <b>Syarat Nilai A</b>
                        <p style="color: #475569; font-size: 14px;" id="syaratA">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Animi aperiam earum fuga illo, magnam molestias possimus! A aperiam aspernatur ea esse incidunt sunt, veniam vitae! Architecto fugit nemo porro tempora.</p>
                      </div>
                      <div class="col-md-4" style="border-right: 1px solid #cfcbca">
                        <b>Syarat Nilai B</b>
                        <p style="color: #475569; font-size: 14px;" id="syaratB">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Accusantium amet fugit minima mollitia neque. A, assumenda consequuntur delectus doloremque expedita libero molestias necessitatibus non quasi, reiciendis repellendus, rerum sequi voluptatibus?</p>
                      </div>
                      <div class="col-md-4">
                        <b>Syarat Nilai C</b>
                        <p style="color: #475569; font-size: 14px;" id="syaratC">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eaque impedit iusto quaerat quas voluptatem. Assumenda doloremque eaque ipsa molestias ullam?</p>
                      </div>
                    </div>

                    <div class="row">
                      <div class="col-md-6">
                        <div class="form-group mb-3">
                          <label class="mb-1" for="tanggalPenugasan"><b>Tanggal penugasan/mulai</b></label>
                          <input type="date" name="tanggalPenugasan" id="tanggalPenugasan" required class="form-control">
                        </div>
                        <div class="form-group mb-3">
                          <label class="mb-1" for="deskripsiPenugasan"><b>Deskripsi</b></label>
                          <textarea name="deskripsiPenugasan" id="deskripsiPenugasan" required class="form-control"></textarea>
                        </div>
                      </div>
                      <div class="col-md-6">
                        <div class="form-group mb-3">
                          <label class="mb-1" for="tanggal"><b>Tanggal realisasi/selesai</b></label>
                          <input type="date" name="tanggal" id="tanggal" required class="form-control">
                        </div>
                        <div class="form-group mb-3">
                          <label class="mb-1" for="deskripsi"><b>Deskripsi</b></label>
                          <textarea name="deskripsi" id="deskripsi" required class="form-control"></textarea>
                        </div>
                      </div>
                      <div class="row">
                        <div class="form-group mb-3">
                          <label class="mb-1"><b>File</b></label>
                          <div class="row">
                            <div class="col-md-12">
                              <div class="table-responsive">
                                <table class="table table-striped table-bordered">
                                  <thead>
                                  <tr>
                                    <th colspan="2" class="text-end">
                                      <button type="button" class="btn btn-outline-success btn-sm" onclick="addFileRow()">Tambah File</button>
                                    </th>
                                  </tr>
                                  </thead>
                                  <tbody id="fileTableBody">
                                  <tr>
                                    <td><input type="file" class="form-control" onchange="validateFileSize(this)" required name="file"></td>
                                    <td><button type="button" class="btn btn-danger btn-sm" onclick="removeFileRow(this)"><i class="fa fa-trash"></i></button></td>
                                  </tr>
                                  </tbody>
                                </table>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                      <div class="form-group mb-3">
                        <button class="btn btn-primary">Simpan</button>
                        <a class="btn btn-danger" onclick="batal()">Batal</a>
                      </div>
                    </div>

                  </div>
                </div>
              </div>

            </div>
          </div>
        </form>
      </div>
    </div>
  </main>
</main>
</body>
</html>
